#ifndef INFER_HPP__
#define INFER_HPP__

#include "common/data.hpp"
#include "common/meta.hpp"


enum class ModelType : int{
    YOLOV5  = 0,
    YOLOV8  = 1,
    YOLO11 = 2,
    YOLO11POSE = 3
};


class Infer{
public:
    virtual data::BoxArray forward() = 0;
}

std::shared_ptr<Infer> load(const std::string& model_path, ModelType model_type, const std::vector<std::string>& names={}, int gpu_id=0, float confidence_threshold=0.5f, float nms_threshold=0.45f);

#endif // INFER_HPP__